// Adrian Budau
// 100 pct

#include <cassert>

#include <iostream>
#include <fstream>
#include <vector>
#include <deque>

const int MAX_N = 1000000;
const long long MAX_BUDGET = 1000000000000000LL;
const int MAX_VAL = 1000000000;

using namespace std;

long long costToAdd(const int &value, deque< pair<int, int> > &Deque) {
    int newSize = 1;
    long long cost = 0;

    while (Deque.size() && value >= Deque.front().first) {
        newSize += Deque.front().second;
        cost += static_cast<long long>(value - Deque.front().first) * Deque.front().second;
        Deque.pop_front();
    }

    Deque.push_front(make_pair(value, newSize));
    return cost;
}

int main() {
    // TODO: change input name
    ifstream cin("calancea.in");
    ofstream cout("calancea.out");

    int N; long long Budget;
    cin >> N >> Budget;
    assert(1 <= N && N <= MAX_N);
    assert(1 <= Budget && Budget <= MAX_BUDGET);

    vector<int> V(N);
    for (int i = 0; i < N; ++i) {
        cin >> V[i];
        assert(0 <= V[i] && V[i] <= MAX_VAL);
    }

    // first we pick the largest from the right
    deque< pair<int, int> > Deque;
    long long currentBudget = 0;
    int bestLeft = -1;
    for (int i = N - 1; i >= 0; --i) {
        currentBudget += costToAdd(V[i], Deque);
        if (currentBudget > Budget) {
            bestLeft = i;
            break;
        }
    }

    long long answer = 0;
    for (int i = N - 1; i >= 0; --i) {
        while (currentBudget <= Budget && bestLeft >= 0) {
            --bestLeft;
            currentBudget += costToAdd(V[bestLeft], Deque);
        }

        answer += i - bestLeft;

        currentBudget -= Deque.back().first - V[i];
        if (--Deque.back().second == 0)
            Deque.pop_back();
    }

    cout << answer << "\n";
}

