// Mugurel Ionut Andreica
// 100 pct

#include <stdio.h>
#include <stdlib.h>

#define NMAX 1111111

long long v[NMAX];
long long X;
int N;

void ReadInput() {
	int i;
	freopen("calancea.in", "r", stdin);
	scanf("%d %lld", &N, &X);
	for (i = 1; i <= N; i++)
		scanf("%lld", &v[i]);
}

int stk[NMAX], p[NMAX], son[NMAX], next_son[NMAX], first_son[NMAX];

void ComputeParentsAndSons() {
	int i, niv, M;
	niv = 0;
	for (i = 1; i <= N; i++) {
		while (niv > 0 && v[stk[niv]] < v[i])
			niv--;
		if (niv > 0)
			p[i] = stk[niv];
		niv++;
		stk[niv] = i;

		//fprintf(stderr, "i=%d:%lld p=%d:%lld\n", i, v[i], p[i], v[p[i]]);
	}

	for (i = N, M = 0; i >= 1; i--)
		if (p[i] > 0) {
			M++;
			son[M] = i;
			next_son[M] = first_son[p[i]];
			first_son[p[i]] = M;
		}
}

int dominating_pos[NMAX], size[NMAX], idpos, jdpos;
long long answer;

void ComputeAnswer() {
	int i, j, k, q;
	long long C;

	answer = C = 0;

	for (i = j = jdpos = N, idpos = N + 1, C = 0; i >= 1; i--) {
		// Add position i.
		size[i] = 1;
		for (k = first_son[i]; k > 0; k = next_son[k]) {
			q = son[k];
			if (q > j)
				break;
			size[i] += size[q];
			idpos++;
			C += (v[i] - v[q]) * size[q];
		}

		idpos--;
		dominating_pos[idpos] = i;
		
		//fprintf(stderr, "  after adding %d: C=%lld\n", i, C);
		
		while (C > X) {
			if (j == dominating_pos[jdpos])
				jdpos--;
			else {
				C -= (v[dominating_pos[jdpos]] - v[j]);
				size[dominating_pos[jdpos]]--;
			}
			j--;
		}
	
		if (dominating_pos[jdpos] > j) {
			fprintf(stderr, "The dominating positions must be between i=%d and j=%d\n", i, j);
			exit(1);
		}
		
		answer += (j - i + 1);

		//fprintf(stderr, "i=%d j=%d first_dom_pos=%d last_dom_pos=%d C=%lld\n", i, j, dominating_pos[idpos], dominating_pos[jdpos], C);
	}
}

void WriteOutput() {
	freopen("calancea.out", "w", stdout);
	printf("%lld\n", answer);
}

int main() {
	ReadInput();
	ComputeParentsAndSons();
	ComputeAnswer();
	WriteOutput();
	return 0;
}
