// Mugurel Ionut Andreica
// 20 pct

#include <stdio.h>
#include <stdlib.h>

#define NMAX 1111111

long long v[NMAX];
long long X;
int N;

void ReadInput() {
	int i;
	freopen("calancea.in", "r", stdin);
	scanf("%d %lld", &N, &X);
	for (i = 1; i <= N; i++)
		scanf("%lld", &v[i]);
}

int stk[NMAX], p[NMAX];

void ComputeParents() {
	int i, niv;
	niv = 0;
	for (i = 1; i <= N; i++) {
		while (niv > 0 && v[stk[niv]] < v[i])
			niv--;
		if (niv > 0)
			p[i] = stk[niv];
		niv++;
		stk[niv] = i;
	}
}

long long sp[NMAX];

void ComputePrefixSums() {
	int i;
	sp[0] = 0;
	for (i = 1; i <= N; i++)
		sp[i] = sp[i - 1] + v[i];
}

int dominating_pos[NMAX], size[NMAX], idpos, jdpos;
long long answer;

void ComputeAnswer() {
	int i, j, k, imin;
	long long C, extra;

	answer = C = 0;

	for (j = N; j >= 1; j--) {
		k = i = j;
		imin = 0;
		C = 0;
		while (i > imin) {
			if (p[i] <= imin) {
				i--;
				k = i;
			} else {
				extra = v[p[i]] * (k - p[i]) - (sp[i - 1] - sp[p[i]]) - v[i] * (k - i + 1);
				if (C + extra <= X) {
					C += extra;
					i = p[i];
				} else
					imin = p[i];
			}
		}

		//fprintf(stderr, "i=%d (k=%d) j=%d C=%lld\n", i, k, j, C);
		answer += (j - i);
	}
}

void WriteOutput() {
	freopen("calancea.out", "w", stdout);
	printf("%lld\n", answer);
}

int main() {
	ReadInput();
	ComputeParents();
	ComputePrefixSums();
	ComputeAnswer();
	WriteOutput();
	return 0;
}
