// Andrei Grigorean
// 100 pct

#include <cassert>

#include <fstream>
using namespace std;

ifstream fin("towerx.in");
ofstream fout("towerx.out");

const int MAX_N = 10000;

int n;
int v[MAX_N + 1];
int d[2][MAX_N + 1];
int sol[MAX_N + 1];

void read() {
    fin >> n;
    assert(1 <= n && n <= MAX_N);
}

void compute_dp() {
    for (int i = 1; i <= n; ++i)
        d[0][i] = 1;
    v[1] = 1;

    int p = 1;
    for (int j = 2; j <= n; ++j) {
        for (int i = j; i <= n; ++i) {
            int first_pos = d[p ^ 1][i];
            int second_pos = d[p ^ 1][i - 1];

            d[p][i] = first_pos + second_pos;
            if (d[p][i] > i) d[p][i] -= i;

            if (i == j) v[i] = d[p][i];
        }
        p ^= 1;
    }
}

void write() {
    int p = 1;
    for (int i = n; i >= 1; --i) {
        for (int stp = 1; stp <= v[i]; ++stp) {
            while (sol[p]) {
                ++p;
                if (p > n) p -= n;
            }
            if (stp < v[i]) {
                ++p;
                if (p > n) p -= n;
            } else {
                sol[p] = i;
            }
        }
    }

    for (int i = 1; i <= n; ++i)
        fout << sol[i] << " ";
}

int main() {
    read();
    compute_dp();
    write();
}
